# excel2anyconv -- Mini Tool for Excel Data to Some Document Bridged by CSV.
#
# Copyright (c) 2006 sakamoto-gsyc-3s@glamenv-septzen.net
#
# == Introduction
#
# Excelt@C̕f[^ERBev[gt@Cɗ݁ACӂ
# `̃eLXgɏo͂B
# JHɂāAExcel̒`t@Ce팾"Define"R[h
# o͂邱ƂړIƂĂB
#
# == Notes
#
# mFWindowsXPSP2 - Ruby 1.8 ōsĂBwin32oleCuK{B
# mFɗpExcelt@COffice2003ō쐬AeA
# Office2000ȍ~łΓɖȂƎvB
# ȂAExcel̑SV[gǂݍ܂B
#
# == Examples
#
# === Workflow Outline
#
# 1. ͑ΏۂExcelt@CpӂB
# 2. ȉ̃R}hsB
# DOS> ruby -KS excel2anyconv.rb Excelt@C cvsdump.erb > csv.txt
# 3. csv.txt̓emFB
# 4. cvsdump.erbRs[Acsv.txtQlɏCB
# 5. Cerbt@CgpāAŏIIȏo͂𓾂B
# DOS> ruby -KS excel2anyconv.rb Excelt@C C.erb > sample.code
#
# === ERBt@Cɂ
#
# "vars"ɂExcel擾f[^Bȉ̂悤ȓ񎟌z
# ƂȂB
# vars = [
#   [(A1), (B1), (C1), ... ],
#   [(A2), (B2), (C2), ... ],
#   [(A3), (B3), (C3), ... ],
# ]
# {IɂCSVf[^ƌȂBCSVƂĂ̏o͂mF邽߂ 
# csvdump.erb͎̂悤ɂȂĂB
#
# <% vars.each do | x | %><% x.each do | y | %><%= y %>, <% end %>
# <% end %>
#
# ŏ"vars.each"ŊesCSVzoA"x.each"CSVz̒g
# o͂ĂB
# csvdump.erb͂܂łCSVmFpłׁASẴf[^\悤ƂB
# ۂɃev[g쐬ꍇ́A"x.each"͎gpAڔz
# CfbNXw肷B
#
# javabean_sample.erb : Java Bean R[hpTv
#     x[1] : ^
#     x[2] : tB[h
#     x[3] : {ꖼ(JavaDocp)
#
# ExcelɊ܂܂̃ZSēǂݍ܂ׁÃR[h炻
# ""f[^菜KvB
#
require 'erb'
require 'win32ole'

class MSExcelIO
	attr_accessor :xls, :book
	
	def self.open(path, &block)
		filename = File::expand_path(path)
		raise "#{filename} is not found" unless File.exist?(filename)

		io = MSExcelIO.new
		xls = WIN32OLE.new('Excel.Application')
		book = xls.Workbooks.Open(filename)
		
		io.xls = xls
		io.book = book
		
		return io unless block_given?
		begin
			yield io
		ensure
			io.close
		end
	end

	def close
		@book.Close
		@xls.Quit
	end

	def readlines
		lines = []
		book.Worksheets.each do | sheet |
			sheet.UsedRange.Rows.each do | row |
				record = []
				row.Columns.each do | cell |
					record << cell.Value
				end
				lines << record
			end
		end
		lines
	end
end

def usage 
	puts "usage: " + __FILE__ + " <Excel File> <ERB Template> "
end

if ARGV.size < 2 then
	usage
	exit(1)
end

vars = MSExcelIO.open(ARGV[0]) { | mso |
	mso.readlines
}

erb_scripts = IO.readlines(ARGV[1]).join;

erb = ERB.new(erb_scripts)
print  erb.result(binding)

